package jp.co.argo21.nautica.ejbtest;

import static org.junit.Assert.*;

import java.util.List;

import jp.co.argo21.nautica.workflow.soap.OrganizationManager;
import jp.co.argo21.nautica.workflow.soap.OrganizationManager_Service;
import jp.co.argo21.nautica.workflow.soap.RoleManager;
import jp.co.argo21.nautica.workflow.soap.RoleManager_Service;
import jp.co.argo21.nautica.workflow.soap.UserManager;
import jp.co.argo21.nautica.workflow.soap.message.Organization;
import jp.co.argo21.nautica.workflow.soap.message.Role;
import jp.co.argo21.nautica.workflow.soap.message.User;

import org.junit.Test;

public class OrgRoleTest {
	
	private Organization org;
	private Role role;


	@Test
	public void unit01_1(){
		try{
			//試験手順
			/*
			OrganizationManager orgManager = SingletonServices.getInstance().getOrganizationManager();
			Organization org = orgManager.getOrganization("E110");
			*/
			
			OrganizationManager_Service om = new OrganizationManager_Service();
			OrganizationManager orgManager = om.getOrganizationManagerPort();
			org = orgManager.getOrganization("E110");
			
			//確認
			assertEquals("企画営業部一課", org.getName());
		} catch (Exception e){
			e.printStackTrace();
			fail();
		}
	}
	
	
	@Test
	public void unit1_2(){
		try{
			//試験手順
			/*
			OrganizationManager orgManager = SingletonServices.getInstance().getOrganizationManager();
			Organization org = orgManager.getOrganization("E110");
			User[] users = orgManager.getAssignedUser(org);
			*/
			
			OrganizationManager_Service om = new OrganizationManager_Service();
			OrganizationManager orgManager = om.getOrganizationManagerPort();
			org = orgManager.getOrganization("E110");
			List<User> users = orgManager.getAssignedUser(org);
			
			//確認
			assertEquals("UID110001", users.get(0).getId());
		}catch (Exception e){
			e.printStackTrace();
			fail();
		}
	}
	
	
	@Test
	public void unit1_3(){
		try{
			//試験手順
			/*
			OrganizationManager orgManager = SingletonServices.getInstance().getOrganizationManager();
			Organization org = orgManager.getOrganization("E110");
			Organization highOrg = orgManager.getHigherOrganization(org);
			*/
			
			OrganizationManager_Service om = new OrganizationManager_Service();
			OrganizationManager orgManager = om.getOrganizationManagerPort();
			org = orgManager.getOrganization("E110");
			Organization highOrg = orgManager.getHigherOrganization(org);
			System.out.println(highOrg.getName());
			//確認
			assertEquals("企画営業部", highOrg.getName());
		} catch (Exception e){
			e.printStackTrace();
			fail();
		}
	}
	
	
	@Test
	public void unit2_1(){
		try{
			//試験手順
			/*
			RoleManager roleManager = SingletonServices.getInstance().getRoleManager();
			Role role = roleManager.getRole("EMPLOYEE_ROLE");
			*/
			
			RoleManager_Service rm = new RoleManager_Service();
			RoleManager roleManager = rm.getRoleManagerPort();
			role = roleManager.getRole("EMPLOYEE_ROLE");
			System.out.println(role.getName());
			//確認
			assertEquals("一般社員ロール", role.getName());
		} catch (Exception e){
			e.printStackTrace();
			fail();
		}
	}
	
	
	@Test
	public void unit2_2(){
		try{
			//試験手順
			/*
			OrganizationManager orgManager = SingletonServices.getInstance().getOrganizationManager();
			Organization org = orgManager.getOrganization("J100");
			RoleManager roleManager = SingletonServices.getInstance().getRoleManager();
			Role[] role = roleManager.getAttachedRoles(org);
			*/
			
			OrganizationManager_Service om = new OrganizationManager_Service();
			OrganizationManager orgManager = om.getOrganizationManagerPort();
			org = orgManager.getOrganization("J100");
			RoleManager_Service rm = new RoleManager_Service();
			RoleManager roleManager = rm.getRoleManagerPort();
			List<Role> role = roleManager.getAttachedRoles1(org);
			System.out.println(role.get(0).getName());
			//確認
			assertEquals("人事部ロール", role.get(0).getName());
		} catch (Exception e){
			e.printStackTrace();
			fail();
		}
	}
	
	
	@Test
	public void unit2_3(){
		try{
			//試験手順
			/*
			RoleManager roleManager = SingletonServices.getInstance().getRoleManager();
			Role role = roleManager.getRole("KIKAKU_ROLE");
			Organization[] orgs = roleManager.getOrganizationsByRole(role);
			*/
			
			RoleManager_Service rm = new RoleManager_Service();
			RoleManager roleManager = rm.getRoleManagerPort();
			role = roleManager.getRole("KIKAKU_ROLE");
			List<Organization> orgs = roleManager.getOrganizationsByRole(role);
			System.out.println(orgs.get(0).getName());
			
			//確認
			assertEquals("企画営業部", orgs.get(0).getName());
		} catch (Exception e){
			e.printStackTrace();
			fail();
		}
	}
	
	
	@Test
	public void unit2_4(){
		try{
			//試験手順
			/*
			RoleManager roleManager = SingletonServices.getInstance().getRoleManager();
			Role role = roleManager.getRole("JINJI_BUCHO_ROLE");
			User[] users = roleManager.getUsersByRole(role);
			*/
			
			RoleManager_Service rm = new RoleManager_Service();
			RoleManager roleManager = rm.getRoleManagerPort();
			role = roleManager.getRole("JINJI_BUCHO_ROLE");
			List<User> users = roleManager.getUsersByRole(role);
			System.out.println(users.get(0).getId());
			
			//確認
			assertEquals("UID200001", users.get(0).getId());
		} catch (Exception e){
			e.printStackTrace();
			fail();
		}
	}
}
